#include "cube.h"

Cube::Cube(GLfloat newX, GLfloat newY, GLfloat newZ,
		   GLfloat newR, GLfloat newG, GLfloat newB,
           GLfloat newXSize, GLfloat newYSize, GLfloat newZSize) {
	x = newX;
	y = newY;
	z = newZ;

	xSize = newXSize;
	ySize = newYSize;
	zSize = newZSize;

	r = newR;
	g = newG;
	b = newB;
}

void Cube::draw() {
	glColor3f(r, g, b);

	glBegin(GL_QUADS);
		//top face
		glVertex3f(x+xSize, y+ySize, z+zSize);
		glVertex3f(x+xSize, y+ySize, z-zSize);
		glVertex3f(x-xSize, y+ySize, z-zSize);
		glVertex3f(x-xSize, y+ySize, z+zSize);

		//bottom face
		glVertex3f(x+xSize, y-ySize, z+zSize);
		glVertex3f(x+xSize, y-ySize, z-zSize);
		glVertex3f(x-xSize, y-ySize, z-zSize);
		glVertex3f(x-xSize, y-ySize, z+zSize);

		//right face
		glVertex3f(x+xSize, y+ySize, z+zSize);
		glVertex3f(x+xSize, y+ySize, z-zSize);
		glVertex3f(x+xSize, y-ySize, z-zSize);
		glVertex3f(x+xSize, y-ySize, z+zSize);

		//left face
		glVertex3f(x-xSize, y+ySize, z+zSize);
		glVertex3f(x-xSize, y+ySize, z-zSize);
		glVertex3f(x-xSize, y-ySize, z-zSize);
		glVertex3f(x-xSize, y-ySize, z+zSize);

		//front face
		glVertex3f(x+xSize, y+ySize, z+zSize);
		glVertex3f(x-xSize, y+ySize, z+zSize);
		glVertex3f(x-xSize, y-ySize, z+zSize);
		glVertex3f(x+xSize, y-ySize, z+zSize);

		//back face
		glVertex3f(x+xSize, y+ySize, z-zSize);
		glVertex3f(x-xSize, y+ySize, z-zSize);
		glVertex3f(x-xSize, y-ySize, z-zSize);
		glVertex3f(x+xSize, y-ySize, z-zSize);
	glEnd();
}