#include <GL/glut.h>

#include "cube.h"
#include "vector3.h"

GLsizei winWidth = 640, winHeight = 480;

Cube firstCube(50, 200, 13, 1, 0, 0, 12, 12, 12);

Vector3 playerPosition;
Vector3 playerDirection;
Vector3 playerUp;

void setPerspectiveProjection() {
	GLfloat aspectRatio = (GLfloat)winWidth/winHeight;

	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();
	gluPerspective (30, aspectRatio, 1, 1000);
	glMatrixMode (GL_MODELVIEW);

	glutSetWindowTitle("Perspective Projection");
}

void init(void) {
	glClearColor (0.5, 0.5, 0.5, 0.0);
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glEnable(GL_DEPTH_TEST);
	
	setPerspectiveProjection();

	playerPosition.setXYZ(400, 250, 20);
	playerDirection.setXYZ(-1, 0, 0);
	playerUp.setXYZ(0, 0, 1);
}

void display (void) {
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	Vector3 lookAtPoint(playerPosition + playerDirection);

	glPushMatrix();
	gluLookAt(playerPosition.getX(), playerPosition.getY(), playerPosition.getZ(),
	          lookAtPoint.getX(), lookAtPoint.getY(), lookAtPoint.getZ(),
			  playerUp.getX(), playerUp.getY(), playerUp.getZ());
	firstCube.draw();
	
	glColor3f(0,0,1);
	glBegin (GL_POLYGON);
		glVertex3f(500,0,0);
		glVertex3f(0,0,0);
		glVertex3f(0,500,0);
		glVertex3f(500,500,0);
	glEnd ();

	glPopMatrix();

	glutSwapBuffers ();
}

void keyboard(unsigned char key, int x, int y) {

}

void mouseButtons(int button, int state, int x, int y) {

}

void main (int argc, char** argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition (50, 100);
	glutInitWindowSize(winWidth, winHeight);
	glutCreateWindow("Interactive Cube Program");

	init();
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouseButtons);
	glutPostRedisplay ();

	glutMainLoop();
}